package it.amattioli.locate;

import java.util.Collection;

import it.amattioli.applicate.commands.AbstractBeanEditor;
import it.amattioli.applicate.context.hibernate.SameContext;

public class AddressEditor extends AbstractBeanEditor<Address>  {
	private PlaceSelector placeSelector;

	@Override
	public void setEditingBean(Address editingBean) {
		super.setEditingBean(editingBean);
		if (placeSelector != null) {
			placeSelector.bindTo(getEditingBean(), "place");
		}
		firePropertyChange(null, null, null);
	}

	public String getStreet() {
		return getEditingBean().getStreet();
	}

	public void setStreet(String street) {
		getEditingBean().setStreet(street);
	}
	
	public Place getProvince() {
		return getEditingBean().getProvince();
	}

	public String getZipCode() {
		return getEditingBean().getZipCode();
	}
	
	public void setZipCode(String zipCode) {
		getEditingBean().setZipCode(zipCode);
	}
	
	public Collection<String> getZipCodeValues() {
		return getEditingBean().getZipCodeValues();
	}

	@SameContext
	public void setPlaceSelector(PlaceSelector placeSelector) {
		this.placeSelector = placeSelector;
		if (getEditingBean() != null) {
			placeSelector.bindTo(getEditingBean(), "place");
		}
	}
	
	public PlaceSelector getPlaceSelector() {
		return placeSelector;
	}
}
