package it.amattioli.locate.memory;

import it.amattioli.locate.Place;
import it.amattioli.locate.PlaceType;

import java.lang.reflect.InvocationTargetException;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.Stack;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.beanutils.ConvertUtils;
import org.apache.commons.beanutils.Converter;

public class PlaceRepositoryContentBuilder {
	static {
		ConvertUtils.register(new Converter() {

			@Override
			public Object convert(Class type, Object value) {
				return new Locale((String)value);
			}
			
		}, Locale.class);
	}

	private Place current;
	private Stack<Place> parents = new Stack<Place>();
	private Map<Long, Place> repositoryContent = new HashMap<Long, Place>();

	public void newPlace(String type, Long id) {
		parents.push(current);
		current = new Place();
		current.setId(id);
		setType(type);
		current.setParent(parents.peek());
	}
	
	private void setType(String type) {
		try {
			BeanUtils.setProperty(current, "type", type);
		} catch (IllegalAccessException e) {
			// TODO Utilizzare una ConfigurationException
			throw new RuntimeException(e);
		} catch (InvocationTargetException e) {
			// TODO Utilizzare una ConfigurationException
			throw new RuntimeException(e);
		}
	}
	
	public void setCode(String name, String value) {
		current.setCode(name, value);
	}
	
	public void setProperty(String name, String value) {
		try {
			BeanUtils.setProperty(current, name, value);
		} catch (IllegalAccessException e) {
			// TODO Utilizzare una ConfigurationException
			throw new RuntimeException(e);
		} catch (InvocationTargetException e) {
			// TODO Utilizzare una ConfigurationException
			throw new RuntimeException(e);
		}
	}
	
	public void addDescription(String description) {
		if (current == null) {
			// TODO Utilizzare una ConfigurationException
			throw new RuntimeException();
		}
		current.setDescription(description);
	}
	
	public void addZipCode(String code) {
		if (current == null) {
			// TODO Utilizzare una ConfigurationException
			throw new RuntimeException();
		}
		current.addZipCode(code);
	}
	
	public void endPlace() {
		repositoryContent.put(current.getId(),current);
		current = parents.pop();
	}

	public Map<Long, Place> getRepositoryContent() {
		return repositoryContent;
	}
	
}
